import numpy as np
from .strategy import Strategy

from torch.utils.data import Subset

class LeastConfidence(Strategy):
    def __init__(self, train_dataset, train_raw_dataset, test_dataset, idxs_lb, net, args):
        super(LeastConfidence, self).__init__(train_dataset, train_raw_dataset, test_dataset, idxs_lb, net, args)

    def query(self, n):
        idxs_unlabeled = np.arange(self.n_pool)[~self.idxs_lb]
        probs = self.predict(Subset(self.train_dataset, idxs_unlabeled))
        U = probs.max(1)[0]
        return idxs_unlabeled[U.sort()[1][:n]]
